=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2011-05-02 17:01:39 +0000
+++ bzrlib/repository.py	2011-05-08 12:54:20 +0000
@@ -3521,6 +3521,15 @@
             raise errors.IncompatibleRepositories(source, target,
                 "different serializers")
 
+    @classmethod
+    def _get_repo_format_to_test(self):
+        return []
+
+    @classmethod
+    def is_compatible(cls, source, target):
+        # The default implementation is compatible with everything
+        return True
+
 
 class InterSameDataRepository(InterRepository):
     """Code for converting between repositories that represent the same data.
@@ -3882,6 +3891,7 @@
         return basis_id, basis_tree
 
 
+InterRepository.register_optimiser(InterRepository)
 InterRepository.register_optimiser(InterDifferingSerializer)
 InterRepository.register_optimiser(InterSameDataRepository)
 

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2011-04-17 23:06:22 +0000
+++ bzrlib/tree.py	2011-05-08 12:54:20 +0000
@@ -936,6 +936,12 @@
 
     _optimisers = []
 
+    @classmethod
+    def is_compatible(kls, source, target):
+        # The default implementation is naive and uses the public API, so
+        # it works for all trees.
+        return True
+
     def _changes_from_entries(self, source_entry, target_entry,
         source_path=None, target_path=None):
         """Generate a iter_changes tuple between source_entry and target_entry.
@@ -1310,6 +1316,9 @@
                     yield result
 
 
+InterTree.register_optimiser(InterTree)
+
+
 class MultiWalker(object):
     """Walk multiple trees simultaneously, getting combined results."""
 

